SystemOrganization addCategory: 'DAO-TP-Changes-Server'!

Object subclass: #SistemaDeCambiosInterfazTCP_Server
	instanceVariableNames: 'connectionSocket mutexParaCommit listenPort sistemaDeCambios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes-Server'!

!SistemaDeCambiosInterfazTCP_Server class methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/4/2013 02:12'!
listenOn: aPort for: aSistemaDeCambios
	aPort isInteger
		ifTrue: [ 
			^self new initializeWith: aPort and: aSistemaDeCambios.
		]
		ifFalse: [ 
			Exception new signal: 'Puerto invlido'.
		]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 02:03'!
decodificar: aByteString 
^
	(NeoJSONReader on: aByteString readStream)
		for: DateAndTime customDo: [ :mapping |
			mapping decoder: [ :string | DateAndTime fromString: string ].
			mapping encoder: [ :dateAndTime | dateAndTime printString ]
		];
		next.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'debug 12/11/2013 20:08'!
handle: aByteString 
| dic anAuthor aClock intEntrada |
	dic := self decodificar: aByteString.
	(dic keys asSet = self validSet) ifTrue:[
		anAuthor := dic at: 'a'.
		intEntrada := InterfazDeEntradaDelSistemaDeCambios remotoWith: sistemaDeCambios andThisAuthor: anAuthor andThisClock: DateAndTime.
		intEntrada perform: ((dic at: 'm') at: 'selector') asSymbol withArguments: ((dic at: 'm') at:'args').
	]
	ifFalse:[
		Exception new signal: 'Comando Invlido'.
	]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Maxi 12/11/2013 19:49'!
initializeWith: aPort and: aSistemaDeCambios 
	listenPort := aPort.
	sistemaDeCambios := aSistemaDeCambios.
	mutexParaCommit := Semaphore forMutualExclusion.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'debug 12/11/2013 20:07'!
interactOnConnection 
	| interactionSocket |
	interactionSocket := connectionSocket accept.
	interactionSocket ifNil: [ self halt: 'interactionSocket es nil.'].
	[self interactUsing: interactionSocket] fork.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'debug 12/11/2013 20:07'!
interactUsing: interactionSocket
	| recibido |
	[
		mutexParaCommit wait.
		recibido := interactionSocket read: 1024.
		recibido ifNil: [ self halt: ' recibido es nil' ].
		self handle: recibido asString.		
		System commit.
		mutexParaCommit signal.
		interactionSocket write: 'Recibido Ok ;-P'.
	] ensure: [
		interactionSocket close.
	]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'debug 12/11/2013 20:07'!
serve
	[
		[ true ] whileTrue: [ self interactOnConnection ] 
	] ensure: [
		connectionSocket close.
	]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'debug 12/11/2013 20:07'!
start
	connectionSocket := GsSocket new makeServer: 10 atPort: listenPort.
	connectionSocket ifNil: [ self halt: 'connectionSocket es nil' ].
	self serve.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'debug 12/11/2013 20:08'!
stop
	connectionSocket isActive ifTrue: [ 
		connectionSocket close.
		].! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 19:34'!
validSet
	^Set new
		add: 'm';
		add: 'a';
		add: 'c';
		yourself! !

TestCase subclass: #SDCITCPS_Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes-Server'!

!SDCITCPS_Test methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 01:41'!
mandameUnSms: aPort
	| ss |
	"ss := SocketStream openConnectionToHostNamed: '127.0.0.1' port: aPort."
	ss := SpSocket connectToServerOnHost: 'localhost' port: aPort .
	[
		ss write: '{"m":{"args":["Nombre-De-Categoria"],"selector":"classCategoryCreated:"},"a":"Seba","c":"2013-12-04T00:51:54.334-03:00"}'.
	] ensure: [ ss close ]! !

!SDCITCPS_Test methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 18:21'!
test01
| unSistemaDeCambios unServer aPort |
	[
		aPort := 9901.
		unSistemaDeCambios := SistemaDeCambios new.
		unServer := SistemaDeCambiosInterfazTCP_Server listenOn: aPort for: unSistemaDeCambios.
		unServer start.
		self assert:(unSistemaDeCambios todosLosCambios isEmpty).
		self mandameUnSms: aPort.
		(Delay forSeconds: 5) wait.
		self assert: (unSistemaDeCambios todosLosCambios size > 0).		
	] ensure: [ unServer stop ]! !
